include file.e
include random.e

sequence derek, brown
sequence record2, record4, test
integer fn
atom key
key = -1

puts(1,"Euphoria Random File Access Library Tutorial\n")
puts(1,"\n")
puts(1,"This library will allow you to use random access in Euphoria.  Please read\n")
puts(1,"the readme.txt for complete info on this library.\n")
puts(1,"Random.e\n")
puts(1,"By: Derek Brown\n")
puts(1,"Email: tidefball@aol.com\n")
puts(1,"\n")
puts(1,"Thanks go out to Rob Craig for Euphoria, and Gabriel Boehme for the binary\n")
puts(1,"versions of print() and get()\n")

while key = -1 do
key = get_key()
end while
key = -1
clear_screen()
puts(1,"We'll start by declaring two sequences.\n")
puts(1,"\n")
puts(1,"derek = {1,2,{3,4,5},6,7,8}\n")
puts(1,"brown = {\"Los numeros cientos\",100,200,300,400,500,600,700,800,900,1000}\n")
puts(1,"\n")

derek = {1,2,{3,4,5},6,7,8}
brown = {"Los numeros cientos",100,200,300,400,500,600,700,800,900,1000}

while key = -1 do
key = get_key()
end while
key = -1
clear_screen()

puts(1,"To write data, the output() command is used.  We'll write derek 3 times\n")
puts(1,"and brown once to the file \"mydata\".\n")
puts(1,"\n")
puts(1,"Syntax: output(integer fn, object variable)\n")
puts(1,"\n")
puts(1,"Source code example:\n")
puts(1,"fn = open(\"mydata\",\"w\")\n")
puts(1,"output(fn,derek)\n")
puts(1,"output(fn,derek)\n")
puts(1,"output(fn,derek)\n")
puts(1,"output(fn,brown)\n")
puts(1,"close(fn)\n")

while key = -1 do
key = get_key()
end while
key = -1

fn = open("mydata","w")
output(fn,derek)
output(fn,derek)
output(fn,derek)
output(fn,brown)
close(fn)

clear_screen()
puts(1,"Derek was stored as the first three records, and brown was stored as\n")
puts(1,"the last record.  To load the data back into a variable, use the\n")
puts(1,"input function.  We'll look at records 2 and 4.\n")
puts(1,"\n")
puts(1,"Syntax: sequence var = input(integer fn, atom rec_num)\n")
puts(1,"\n")
puts(1,"Source code example:\n")
puts(1,"fn = open(\"mydata\",\"r\")\n")
puts(1,"record2 = input(fn,2)\n")
puts(1,"record4 = input(fn,4)\n")
puts(1,"close(fn)\n")

fn = open("mydata","r")
 record2 = input(fn,2)
 record4 = input(fn,4)
close(fn)

while key = -1 do
key = get_key()
end while
key = -1

puts(1,"\n")
puts(1,"\n")
puts(1,"Now printing record2 and record4\n")
puts(1,"\n")

print(1,record2)
puts(1,"\n")
print(1,record4)
puts(1,"\n")

puts(1,"(Remember, brown[1] was the string \"Los numeros cientos.\"\n")

while key = -1 do
key = get_key()
end while
key = -1
clear_screen()

puts(1,"To overwrite data, we use the over_write() command.  We'll overwrite the\n")
puts(1,"first record, which was a derek, and put a brown there.\n")
puts(1,"IMPORTANT:  You must be in \"update\" mode to over_write()!\n")
puts(1,"\n")
puts(1,"Syntax: over_write(atom fn, atom rec#, object record)\n")
puts(1,"\n")
puts(1,"Source code example:\n")
puts(1,"fn = open(\"mydata\",\"u\")\n")
puts(1,"over_write(fn, 1, brown)\n")
puts(1,"close(fn)")

fn = open("mydata","u")
over_write(fn, 1, brown)
close(fn)

while key = -1 do
key = get_key()
end while
key = -1

puts(1,"\n")
puts(1,"\n")
puts(1,"Now inputting and printing record 1 to confirm overwrite\n")
puts(1,"(And for review, here is how to input again)\n")
puts(1,"\n")
puts(1,"Source code example:\n")
puts(1,"fn = open(\"mydata\",\"r\")\n")
puts(1,"test = input(fn,1)\n")
puts(1,"close(fn)\n")
puts(1,"\n")

fn = open("mydata","r")
test = input(fn,1)
close(fn)
print(1,test)

while key = -1 do
key = get_key()
end while
key = -1
clear_screen()

puts(1,"The replace() procedure can also be used to overwrite data, however, the\n")
puts(1,"new record must be the same length as the old record.  In a large database,\n")
puts(1,"replace() can be up to twice as fast.\n")
puts(1,"\n")
puts(1,"The commands output(), input(), over_write(), and replace(), make up the ASCII\n")
puts(1,"set of random access commands.  Read on to learn about the binary version of\n")
puts(1,"random.e.\n")

while key = -1 do
key = get_key()
end while
key = -1
clear_screen()

puts(1,"For each ASCII command, there is a similar binary version.  For example, you\n")
puts(1,"can use the b_output() command to output data in binary mode.  The syntax\n")
puts(1,"for binary is the same for ASCII, so there is no need to go over it.\n")
puts(1,"\n")
puts(1,"Binary mode is more efficient at storing atoms and sequences that consist\n")
puts(1,"mainly of integers, while ASCII mode is better at storing atoms and sequences\n")
puts(1,"that contain a lot of floating point (decimal) numbers.\n")
puts(1,"\n")
puts(1,"Here is a comparison to show the capabilities of each set:\n")
puts(1,"\n")
puts(1,"Sequence {1,2,3} written 100 times\n")
puts(1,"ASCII mode  - 800 bytes\n")
puts(1,"Binary mode - 600 bytes\n")
puts(1,"\n")
puts(1,"Sequence {1.5,2.5,3.5} written 100 times\n")
puts(1,"ASCII mode  - 1400 bytes\n")
puts(1,"Binary mode - 3000 bytes\n")
puts(1,"\n")

while key = -1 do
key = get_key()
end while
key = -1
clear_screen()

puts(1,"In conclusion, if you're working with mostly integers, use the binary set.\n")
puts(1,"If you're working with decimals, use the ASCII set.  You can even work with\n")
puts(1,"both types if you prefer.  However, you must use the correct command.  For\n")
puts(1,"example, it's possible to make a database where the first 50 records are ASCII\n")
puts(1,"and the rest are binary.  Just be sure to use input() to read the ASCII records\n")
puts(1,"and b_input() to read the binary records.  Using the wrong command will cause\n")
puts(1,"a type check failure.\n")
puts(1,"\n")
puts(1,"Another command for random access is quantity().\n")
puts(1,"Syntax: atom var = quantity(atom fn)\n")
puts(1,"This returns the number of records there are in the database.\n")
puts(1,"\n")
puts(1,"That concludes the tutorial on the random.e library.  You may freely use the\n")
puts(1,"library in your programs.  You may edit the contents of random.e, but you may\n")
puts(1,"not distribute an altered version without my consent.  Feel free to ask any\n")
puts(1,"questions about the library and the commands.")

