--Random.e v2.0
--March 31 1999
--Derek Brown
--Email: tidefball@aol.com

--You may freely alter the contents of this file, however, you may not
--distribute this if changed without my permission.

--Read the readme.txt for complete instructions.

include file.e
include get.e
include bget.e
without type_check

integer j
sequence temp,tracks,record,save

function map_tracks(atom fn)
--Used to make map of tracks to locate records
  tracks = {}
  temp = {}
  j = seek(fn,0)
  temp = gets(fn)
  for i = 1 to length(temp) do
    if temp[i] = 94 then
      tracks = tracks & i
    end if                      
  end for
  return tracks  
end function

global function input(atom fn, atom rec_num)
--Inputs data from file into a variable
  if rec_num = 0 then
    rec_num = 1
  end if
  record = {}
  tracks = map_tracks(fn)
  if rec_num > length(tracks) then
    rec_num = length(tracks)
  end if
  j = seek(fn,tracks[rec_num])
  record = get(fn)
  return record[2]
end function

global procedure output(atom fn, object record)
--Writes data to the file
  puts(fn,'^')
  print(fn,record)  
end procedure

global procedure replace(atom fn, atom rec_num, object record)
--Over writes a record of same length
  tracks = map_tracks(fn)
  if rec_num > length(tracks) then
    rec_num = length(tracks)
  end if
  j = seek(fn,tracks[rec_num])
  print(fn,record)
end procedure

global procedure over_write(atom fn, atom rec_num, object record)
--Over writes a record of different length than old
  save = {}
  tracks = map_tracks(fn)
  if rec_num > length(tracks) then
    rec_num = length(tracks)
  end if
  if rec_num = length(tracks) then
    puts(fn,'^')
    print(fn,record)
  else
    j = seek(fn,tracks[rec_num + 1])
    save = gets(fn)
    j = seek(fn,tracks[rec_num])
    print(fn,record)
    puts(fn,'^')
    puts(fn,save)
  end if
end procedure

global function quantity(atom fn)
--Returns the number of records in a datafile
  tracks = map_tracks(fn)
  return length(tracks)
end function

--Binary functions

global function b_input(atom fn, atom rec_num)
--Inputs data from file into a variable
  if rec_num = 0 then
    rec_num = 1
  end if
  record = {}
  tracks = map_tracks(fn)
  if rec_num > length(tracks) then
    rec_num = length(tracks)
  end if
  j = seek(fn,tracks[rec_num])
  record = bget(fn)
  return record[2]
end function

global procedure b_output(atom fn, object record)
--Writes data to the file
  puts(fn,'^')
  bprint(fn,record)  
end procedure

global procedure b_replace(atom fn, atom rec_num, object record)
--Over writes a record of same length
  tracks = map_tracks(fn)
  if rec_num > length(tracks) then
    rec_num = length(tracks)
  end if
  j = seek(fn,tracks[rec_num])
  bprint(fn,record)
end procedure

global procedure b_over_write(atom fn, atom rec_num, object record)
--Over writes a record of different length than old
  save = {}
  tracks = map_tracks(fn)
  if rec_num > length(tracks) then
    rec_num = length(tracks)
  end if
  if rec_num = length(tracks) then
    puts(fn,'^')
    bprint(fn,record)
  else
    j = seek(fn,tracks[rec_num + 1])
    save = gets(fn)
    j = seek(fn,tracks[rec_num])
    bprint(fn,record)
    puts(fn,'^')
    puts(fn,save)
  end if
end procedure

